<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="图片" prop="image">
        <Materials v-model="formData.image" num="1" type="image" />
      </el-form-item>
      <el-form-item label="是否可用" prop="isSwitch">
        <el-radio-group v-model="formData.isSwitch">
          <el-radio :label="1">是</el-radio>
          <el-radio :label="0">否</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="权重" prop="weigh">
        <el-input v-model="formData.weigh" placeholder="请输入权重" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { AdsApi, AdsVO } from '@/api/score/scoreads'

/** 积分商城广告图管理 表单 */
defineOptions({ name: 'AdsForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  image: undefined,
  isSwitch: undefined,
  weigh: undefined,
  shopName: undefined
})
const formRules = reactive({
  image: [{ required: true, message: '图片不能为空', trigger: 'blur' }],
  isSwitch: [{ required: true, message: '是否显现不能为空', trigger: 'blur' }],
  weigh: [{ required: true, message: '权重不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await AdsApi.getAds(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as AdsVO
    if (formType.value === 'create') {
      await AdsApi.createAds(data)
      message.success(t('common.createSuccess'))
    } else {
      await AdsApi.updateAds(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    image: undefined,
    isSwitch: 1,
    weigh: 0,
    shopName: undefined
  }
  formRef.value?.resetFields()
}
</script>